# FASPEX 4.4.1 PATCH Level 8
**Operating Systems:** Linux and Windows
**Date:** 07/27/2021

This patch includes the following fixes:

### Patch Level 8 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-2018 | Updated HA setup instructions to direct customers to share `/opt/aspera/faspex/app/views/notifier/` via shared storage.                                                      |
| FASPX-2016 | You can now set `multi_session` to 0 to disable multi session upload and download.                                                       |
| FASPX-2007 | Fixed an issue where the `remote_host` property in a session defaulted to `nil` instead of to an empty string.                                                       |
| FASPX-2003 | Fixed an issue where Stats Collector did not properly handle null values resulting in 'Upload never started' error.|
| FASPX-1944 | Upgraded ACM version from 1.98 to 2.00.                                                                                         |
| FASPX-1908 | Fixed an issue where users were not able to set minimum Connect version to 3.10.0.                                                                             |

### ACM Upgrade
After installing the patch, verify that the `/opt/aspera/acm` folder has the
correct permissions. Faspex requires these permissions:
```
ls -lR /opt/aspera/acm/
# /opt/aspera/acm/:
# total 0
# drwxrwx--- 2 root root 80 bin
# drwxrwxr-x 2 root root 26 config
# drwxrwx--- 2 root root  6 log
# drwxrwxr-x 2 root root 24 run
# /opt/aspera/acm/bin:
# total 188
# -rwxr-x--- 1 root root   15779 acm
# -rw-r--r-- 1 root root   1038 acmcommon
# -rwxr-x--- 1 root root   9596 acmctl
# -rwxr-x--- 1 root root 147936 aslockfile
# -rwxr-x--- 1 root root   6239 drsync
# /opt/aspera/acm/config:
# total 4
# -rw------- 1 faspex faspex 146 database.yml
# /opt/aspera/acm/log:
# total 0 |
# /opt/aspera/acm/run:
# total 4
# -rw-r--r-- 1 root root 30 acm.status
```

### Patch Level 7 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-1992 | When HTTP Gateway is enabled, the Connect installer sometimes prompts external users multiple times to use Connect. |
| FASPX-1966 | The Connect 3.10.0 installer does not allow switching to the HTTP-Gateway experience in some cases. |
| FASPX-1939 | Users authenticating through the API are locked out of their accounts before reaching the max number of failed attempts to log in. |
| FASPX-1909 | When using a custom URI namespace, Faspex uses the wrong URI namespace for disabling Connect, preventing end users from disabling Connect to use HTTP Gateway.  |
| FASPX-1845 | Faspex does not sanitize parameters in the external delivery URLs. |
| FASPX-1836 | A downloaded, forwarded package incorrectly includes the original package metadata instead of package metadata for the forwarded package. |

### Notes related to Connect 3.10 and HTTP Gateway:

Aspera highly recommends customers upgrade their Connect SDK version to 3.11 for fixes related to the HTTP Gateway experience:

1. Download the SDK [here](http://ibm.biz/Connect311SDK)
2. On your Faspex server, create this folder (if it doesn't exist already): `/opt/aspera/faspex/public/connect`
3. Extract the Connect SDK to the `connect` folder.
```
# unzip ConnectSdk.zip -d /opt/aspera/faspex/public/connect
```
4. Give Faspex permissions and ownership of the new Connect directory.
```
# chown -R faspex:faspex /opt/aspera/faspex/public/connect
# chmod -R 755 /opt/aspera/faspex/public/connect
```
5. In the Faspex UI, go to **Server > Configuration > Transfer Options** and select **Locally host Connect**.

### Patch Level 6 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-1893 | External users are still able to upload using HTTP even if the invitation is set to `Prevent HTTP upload for this package`. |
| FASPX-1874 | Relays fail when tag size set via `MaxTagsLength` is too small. |
| FASPX-1869 | The jQuery version does not include the latest security benefits.                                                         |
| FASPX-1854 | Email addresses set as a CC recipient of a package also receive a copy of each email sent to each package recipient. |

### Patch Level 5 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-1818 | The `/users` API endpoint returns 500 instead of 404 when Faspex cannot find a user and no paging variable is provided.|
| FASPX-1815 | Faspex does not notify relay recipients when a relay is requested but no transfer is needed because the package already exists at the destination.                                                        |
| FASPX-1808 | Column in relays page table does not show `Completed Relays`.                                                                  |
| FASPX-996  | Successful relays remain on the relays page.                                                                                   |

### Patch Level 4 Fixes

| Jira Issue | Description                                                                                                                    |
| ---------- | ------------------------------------------------------------------------------------------------------------------------------ |
| FASPX-1802 | Some Faspex relays fail with a MySQL error.                                                       |
| FASPX-1801 | Faspex duplicates transfers when forwarding a package to a work group with a custom inbox.                                     |
| FASPX-1800 | The `/users` API endpoint performs poorly with a large number of users.                                                                                                   |
| FASPX-1799 | Using the API to request a transfer specification for package downloads triggers package recalculation.                        |
| FASPX-1797 | There is a typo in the error message Faspex displays when a directory user tries to change the account password.               |
| FASPX-1702 | When using Faspex with a language other than English, Faspex errors when performing actions on the **Accounts** tab in the UI. |

### Patch Level 3 Fixes
| Jira Issue | Description                                                                                                                   |
| ---------- |:----------------------------------------------------------------------------------------------------------------------------- |
| FASPX-1789 | Dropbox invitations do not allow users to apply EAR when dropbox or global settings are set to **optional**. Read the notes below to check if your situation requires follow-up actions.|
| FASPX-1783 | The pagination for `/api/users` returns 404 instead of an empty array when `page_num` exceeds page count.                     |

### Notes related to FASPX-1789:

#### THE PROBLEM

Faspex 4.4 introduced the ability to configure, on a per-invitation basis, whether invited submitters are required to upload using encryption-at-rest (EAR). This per-invitation setting overrules dropbox and global settings. Users configure this setting when creating a new invitation. 

Upgrading to Faspex 4.4 sets the EAR requirement of pre-existing invitation to the default of **no**. Since EAR settings are only configurable when creating an invitation, pre-existing invitations do not allow submitters to use EAR when the dropbox or global settings are **optional**.

#### PATCH BEHAVIOR

Applying Patch Level 3 changes the default EAR requirement from **no** to unset. The patch also updates all invitations with EAR requirements set to **no** to inherit settings from the dropbox or global level by leaving the setting unset. Invitations with EAR requirements set to **yes** or **optional** are unaffected. When dropbox or global settings are **optional**, new invitations follow the EAR requirement set when the invitation was created. Otherwise, invitations follow relevant dropbox and global settings.

#### THE FIX

Upgrade to 4.4.1 and apply Patch Level 3 for a full fix.

> **IMPORTANT:** The patch cannot differentiate whether pre-existing invitations with EAR requirements set to **no** were defaulted to **no** from the upgrade to Faspex 4.4 or intentionally set to **no** by a user. If you have invitations that must be set to **no**, you must reissue those invitations.


### Patch Level 2 Fixes
| Jira Issue | Description                                                                                                             |
| ---------- | ----------------------------------------------------------------------------------------------------------------------- |
| FASPX-1779 | Faspex URLs generated using Inbox.Atom use final source share directory instead of the storage share directory.                              |
| FASPX-1778 | Not able to update Faspex package via API after package send.                                                           |
| FASPX-1783 | The pagination for `/api/users` endpoint does not return the correct results when the `page_num` value exceeds the page count. |

<div style="page-break-after: always;"></div>

### Patch Level 1 Fixes

| Jira Issue | Description
| -------- | --------
| FASPX-1773 | Stats Collector logs show unnecessary information.
| FASPX-1772 | Creating users using the /user endpoint requires true and false Boolean values for can_send_normal_packages, can_send_to_external_email, andcan_send_to_all_faspex_users fields.
| FASPX-1770 | User created using the SDK does not inherit server default settings.
| FASPX-1388 | Implemented NoMgmtPortFiles in SOAP payload for remote source transfers.

See the included API reference included in the patch folder (open `IBM_Aspera_Faspex_4.4.1_PL8_api_reference/index.html` in your browser). 

## PATCH INSTRUCTIONS

### Applying the patch for Linux systems:
1. Download the patch file (`IBM_Aspera_Faspex_4.4.1_Linux_Windows_Patch_Level_8.zip`) and unzip it.

2. Make sure to back-up all the files in the faspex folder (`/opt/aspera/faspex/`).

3. Run the following command to replace existing files with patch files:

```bash
$ /bin/cp -r patch_path/ IBM_Aspera_Faspex_4.4.1_Linux_Windows_Patch_Level_8/* /opt/aspera/faspex/
```

4. Change ownership of the `/opt/aspera/faspex` folder to the `faspex` group and `faspex` user:

```
cd /opt/aspera/faspex
chown -R faspex:faspex *
```

5. Restart Faspex service:

```
asctl faspex:restart
```

6. Run the following command to get updated database schema: (Note: Not required if you are applying PL4 patch on top of PL3 patch)

```
asctl faspex:migrate_database
```

6. Confirm the patch was applied by checking the patch level listed in the footer (beneath the version number).

### Applying the patch for Windows systems:
1. Download the patch file (`IBM_Aspera_Faspex_4.4.1_Linux_Windows_Patch_Level_8.zip`) and unzip it.

2. Make sure to back-up all the files in the Faspex folder (`C:\Program Files\Aspera\Faspex\`).

3. Stop all Faspex services:

a. Go to **Control Panel > Administrative Tools > Services**.

b. For every service with Aspera Faspex in the name, right-click on the service and select **Stop** from the drop-down menu.

4. Replace existing files by copying patch files to appropriate directories in the Faspex folder (`C:\Program Files\Aspera\Faspex\`).

5. Restart all Faspex services:

a. Go to **Control Panel > Administrative Tools > Services**.

b. For every service with Aspera Faspex in the name, right-click on the service and select **Start** from the drop-down menu.

6. Run the following command to get updated database schema: (Note: Not required if you are applying the patch on top of PL3 or later patch)

```
asctl faspex:migrate_database
```

7. Confirm the patch was applied by checking the patch level listed in the footer (beneath the version number).

© IBM Aspera. Copyright IBM Corp. 2009, 2021
