#!/bin/bash

# Control script for @SERVICE_DISPLAY_NAME@.
# (c) Aspera Inc.

# Redhat
# chkconfig: 345 85 15
# description: @SERVICE_DISPLAY_NAME@

# LSB block for non-RedHat distributions (e.g. SuSE)
### BEGIN INIT INFO
# Provides:          @SERVICE_NAME@
# Required-Start:    $network @REQUIRED_START@
# Required-Stop:     $network @REQUIRED_STOP@
# Default-Start:     3 4 5
# Default-Stop:      0 1 2 6
# Description:       @SERVICE_DISPLAY_NAME@
### END INIT INFO


# Assumptions:
# * this script is being run as root

# Uncomment to run daemon with a different user account than root
# DAEMON_USER=

# . common-daemon-functions.sh
@COMMON_DAEMON_FUNCTIONS@

CDF_NATIVE_STATUS_REPORTING_ENABLED=true
cdf_init

INSTALL_DIR="$(dirname "$CDF_INSTALL_DIR")"

PRODUCT_NAME="@PRODUCT_NAME@"
PROJECT_NAME="aspera-stats-collector"
LOG_DIR="@LOG_DIR@"
PID_DIR="@PID_DIR@"

CDF_DAEMON_NAME="@SERVICE_NAME@"
CDF_DAEMON_DESC="@SERVICE_DISPLAY_NAME@"
CDF_EXECUTABLE="$CDF_INSTALL_DIR/$PROJECT_NAME"
CDF_PID_FILE="$PID_DIR/$PRODUCT_NAME.pid"
CDF_USAGE="$CDF_USAGE|admin"

DAEMON_MAIN_CLASS="@SERVICE_MAIN_CLASS@"
DAEMON_CLASSPATH="@CPATH@"
JVM_OPTIONS="@JVM_MAX_MEM@ @JVM_OPTIONS@ -Xss2m -Dstatscollector.log.dir="${LOG_DIR}" -XX:ErrorFile="${LOG_DIR}/java_error_%p.log""

ADMIN_MAIN_CLASS="@ADMIN_MAIN_CLASS@"
JVM_OPTIONS_ADMIN="@JVM_MAX_MEM@ @JVM_OPTIONS_ADMIN@ -Xss2m -Dstatscollector.log.dir="${LOG_DIR}""

STDOUT_FILE="$LOG_DIR/${PRODUCT_NAME}_start.log"
STDERR_FILE="$LOG_DIR/${PRODUCT_NAME}_start.log"
JAVA_HOME="@JAVA_HOME@"

cdf_init_start() {
  local USER_OPTION
  
  cdf_create_dir "$PID_DIR" "$DAEMON_USER"
  cdf_create_dir "$LOG_DIR" "$DAEMON_USER"
  cdf_create_dir "$INSTALL_DIR/etc" "$DAEMON_USER"

  [ -n "$DAEMON_USER" ] && USER_OPTION="-user "$DAEMON_USER"" 

  CDF_ARGUMENTS="-wait 10\
     $USER_OPTION\
    -procname "$CDF_DAEMON_NAME"\
    -cp "$DAEMON_CLASSPATH"\
    -outfile "$STDOUT_FILE"\
    -errfile "$STDERR_FILE"\
    -pidfile "$CDF_PID_FILE"\
    -home "$JAVA_HOME"\
    "$JVM_OPTIONS"\
    "$DAEMON_MAIN_CLASS""
}

cdf_start_no_daemon() {
  "$JAVA_HOME/bin/java" $JVM_OPTIONS -cp "$DAEMON_CLASSPATH" "$DAEMON_MAIN_CLASS" "$@"
}

startAdminApp() {
  "$JAVA_HOME/bin/java" $JVM_OPTIONS_ADMIN -cp "$DAEMON_CLASSPATH" "$ADMIN_MAIN_CLASS" "$@"
  CDF_RETVAL=$?
}

cdf_handle_command() {
    case "$1" in
     admin)
        shift
        startAdminApp "$@" 
        ;;
     *)
        cdf_usage "$@"
        ;;
  esac
}

cdf_go "$@"
exit 0
